/*********************************************************************************
**
**   $Id: AcctSelect.cpp,v 1.2 2004/04/03 14:04:53 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qlistbox.h>
#include <qregexp.h>
#include <qsqlquery.h>
#include "AcctSelect.h"

int AcctSelect::getAccount() const
{
   int rv = -1;

   printf("AcctSelect::getAccount(): Enter\n");
   QString aname = currentText();
   QRegExp re(".*:");
   re.setMinimal(true);
   aname.replace(re, "");

   aname.replace(QRegExp("'"), "''");
   QString sql = "select ident from accounts where name = '" + 
                 aname + "'";
   printf("AcctSelect::getAccount(): sql = |%s|\n", (const char*)sql);
   fflush(stdout);
   QSqlQuery q(sql);
   if (q.isActive())
   {
      if (q.next()) 
         rv = q.value(0).toInt();
   }
   printf("AcctSelect::getAccount(): rv = %d\n", rv);
   fflush(stdout);
   printf("AcctSelect::getAccount(): exit\n");
   return(rv);
}

void AcctSelect::setAccount(int a)
{
   QListBoxItem *li;
   QString strIdent, ident;

   printf("AcctSelect::setAccount(): Enter\n");
   strIdent.setNum(a);
   QString sql = "select name from accounts where ident = '" +
                 strIdent + "'";
   printf("AcctSelect::setAccount(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q(sql);
   if (q.isActive())
   {
      if (q.next()) 
         ident = q.value(0).toString();
   }

   li = listBox()->findItem(ident);
   int i = listBox()->index(li);
   listBox()->setSelected(li, true);
   setCurrentItem(i);
   setCurrentText(ident);
   printf("AcctSelect::setAccount(): Setting account |%s|, %d\n", (const char*)ident, i);
   fflush(stdout);
}

void AcctSelect::refresh()
{
   int a = getAccount();
   QStringList accList;
   printf("AcctSelect::refresh(): enter\n");
   QString sql = "select ident, name from accounts where active != 'N' order by name";
   printf("AcctSelect::refresh(): sql = |%s|\n", (const char*)sql);
   QSqlQuery q(sql);
   accList += "";
   if (q.isActive())
   {
      while (q.next()) 
      {
         QString p = q.value(0).toString() + ":" + q.value(1).toString();
         printf("AcctSelect::refresh(): Adding account |%s|\n", (const char*)p);
         fflush(stdout);
         accList += p;
      }
      clear();
      insertStringList(accList);
   }
   setAccount(a);
   printf("AcctSelect::refresh(): exit\n");
}


